<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<!--
IGAC proyecto SNC

@author fredy.wilches
@version 2.0
@description
CU: Generar Resolucion IPER
página principal. Es masiva

-->

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                xmlns:predio="http://java.sun.com/jsf/composite/predio"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                template="../../templates/generalCU.xhtml">

    <ui:define name="title">
        .::Sistema Nacional Catastral::. .::Generar Resoluciones de IPER::.
    </ui:define>

    <ui:define name="content">
        <p:ajaxStatus onstart="statusDialog.show();"
                      onsuccess="statusDialog.hide();"
                      onerror="statusDialog.hide();alert('Error AJAX en la aplicación');" />

        <p:focus />

        <p:fieldset>
            <legend> <h:outputText value="Generar resoluciones de IPER"
                                   styleClass="legendTitle" /> </legend>

            <p:spacer height="10" width="0" />
            <h:form id="tramitesFinalizarForm" prependId="false">
                <p:messages id="msgsAplicCambios" showDetail="false"
                            globalOnly="false" />
                <center>
                    <p:dataTable id="tramitesFinalizarDT"
                                 widgetVar="tramitesDTWV"
                                 value="#{generarResolucionIPER.currentTramites}" var="tramite"
                                 rowKey="#{tramite.numeroRadicacion}" 
                                 paginator="true" rows="10"
                                 paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                 paginatorPosition="bottom" rowsPerPageTemplate="10,20,30"
                                 emptyMessage="No existen trámites para generar resolución"
                                 >
                        <f:facet name="header">
                            Trámites para generar resolución
                        </f:facet>

                        <p:column headerText="Detalle" id="col1">
                            <p:selectBooleanCheckbox value="#{tramite.seleccionAprobar}" id="seleccionado">
                                <p:ajax process="@this"></p:ajax>
                            </p:selectBooleanCheckbox>
                            <p:spacer width="10"></p:spacer>
                            <p:commandButton oncomplete="detalleTramiteWV.show()"
                                             immediate="true" ajax="true" title="Ver detalles del trámite"
                                             update=":detalleTramiteEjecutarForm, :tramitesFinalizarForm:msgsAplicCambios"
                                             icon="ui-icon-search">
                                <f:setPropertyActionListener value="#{tramite}"
                                                             target="#{vistaDetallesTramite.selectedTramiteForDetailsChecking}" />
                            </p:commandButton>
                        </p:column>

                        <p:column headerText="Nro. de solicitud"
                                  sortBy="#{tramite.solicitud.numero}"
                                  filterBy="#{tramite.solicitud.numero}"
                                  filterMatchMode="contains">
                            <h:outputText value="#{tramite.solicitud.numero}"
                                          styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Fecha de la solicitud"
                                  sortBy="#{tramite.solicitud.fecha}">
                            <h:outputText styleClass="outputTextStyle"
                                          value="#{tramite.solicitud.fecha}">
                                <f:convertDateTime pattern="#{general.formatoFechaUsuario2}" />
                            </h:outputText>
                        </p:column>

                        <p:column headerText="Nro. de radicación"
                                  sortBy="#{tramite.numeroRadicacion}"
                                  filterBy="#{tramite.numeroRadicacion}"
                                  filterMatchMode="contains">
                            <h:outputText value="#{tramite.numeroRadicacion}"
                                          styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Fecha de radicación"
                                  sortBy="#{tramite.fechaRadicacion}">
                            <h:outputText styleClass="outputTextStyle"
                                          value="#{tramite.fechaRadicacion}">
                                <f:convertDateTime pattern="#{general.formatoFechaUsuario2}" />
                            </h:outputText>
                        </p:column>

                        <p:column headerText="Tipo de trámite" filterBy="#{tramite.tipoTramiteCadenaCompleto}"
                                  sortBy="#{tramite.tipoTramiteCadenaCompleto}">
                            <h:outputText styleClass="outputTextStyle"
                                          id="TramiteTipoTramiteV"
                                          value="#{tramite.tipoTramiteCadenaCompleto}">
                            </h:outputText>
                        </p:column>

                        <p:column headerText="Nro. predial" filterBy="#{tramite.predio.numeroPredial}" filterMatchMode="contains"
                                  sortBy="#{tramite.predio.numeroPredial}">
                            <h:outputText styleClass="outputTextStyle"
                                          value="#{tramite.predio.numeroPredial}">
                            </h:outputText>
                        </p:column>


                        <p:column headerText="Resolución" filterBy="#{tramite.resultadoDocumento.numeroDocumento}">

                            <p:commandLink 
                                action="#{generarResolucionIPER.consultarDocResolucion}"
                                onstart="statusDialog2.show()" rendered="#{tramite.resultadoDocumento!=null}"
                                oncomplete="statusDialog2.hide();visorReporteWV.show();"
                                title="Ver documento de resolución" process="@this" update=":viewReport" >
                                <h:outputText value="Ver #{tramite.resultadoDocumento.numeroDocumento}" styleClass="commandLinkStyle" />
                                <f:setPropertyActionListener target="#{generarResolucionIPER.selectedTramiteResolucion}" 
                                                             value="#{tramite}" />
                            </p:commandLink>
                        </p:column>

                    </p:dataTable> <p:spacer height="10" width="0" /> <p:separator
                        style="width:1000px;height:3px" /> <p:spacer height="10" width="0" />
                    <p:outputPanel layout="block" style="text-align:right">
                        <p:commandButton value="Generar resoluciones" ajax="true" 
                                         onstart="statusDialog2.show()" oncomplete="statusDialog2.hide()"
                                         action="#{generarResolucionIPER.generarResoluciones}" process="@form"
                                         icon="ui-icon-document" update="tramitesFinalizarForm" />

                        <p:spacer width="20" height="0" />

                        <p:commandButton value="Avanzar procesos" ajax="true" 
                                         onstart="statusDialog2.show()" oncomplete="statusDialog2.hide()"
                                         action="#{generarResolucionIPER.avanzarProcesos}" process="@form"
                                         icon="ui-icon-seek-next" update="tramitesFinalizarForm" />

                        <p:spacer width="20" height="0" />

                        <p:commandButton value="Cerrar" icon="ui-icon-circle-close"
                                         action="#{generarResolucionIPER.cerrarPaginaPrincipal}" ajax="false"
                                         immediate="true" />

                        <p:spacer width="10" height="0" />
                    </p:outputPanel> 
                    <p:spacer width="0" height="20" />
                </center>
            </h:form>
        </p:fieldset>


        <p:dialog header="Detalle del trámite" widgetVar="detalleTramiteWV"
                  modal="true" appendToBody="true" resizable="true" position="center"
                  width="980" height="550">
            <ui:include src="../ejecucion/detalleTramiteEjecucion.xhtml">
                <ui:param name="currentManagedBeanParam"
                          value="#{vistaDetallesTramite}" />
                <ui:param name="currentDetallePredioWV" value="detallePredioWV" />
            </ui:include>
        </p:dialog>

        <predio:detallesPredioCC id="dpCC" thisWVName="detallePredioWV"
                                 mostrarDatosPropietarios="true" mostrarDatosTramites="true"
                                 thisIdPlusColon=":dpCC" />

        <!-- Dialog usado para habilitar el tab de origen del predio -->
        <predio:detallesPredioCC id="dpCC2" thisWVName="detallePredioWV2"
                                 mostrarDatosPropietarios="true" mostrarDatosTramites="true"
                                 mostrarFichaPredial="true" thisIdPlusColon=":dpCC2" />

        <p:dialog header="Número Predial Anterior"
                  widgetVar="numPredAnteriorDlg" appendToBody="true" modal="true"
                  height="500" width="1024"> 
            <ui:include src="../consultarNumeroPredialAnterior.xhtml" />
        </p:dialog>

        <misc:docViewerWithCloseDecisionCC id="docViewer"
                                           confirmUpdate="msgInfoFis" confirmDialogWV="docViewerWV"
                                           ajaxBehavior="true"
                                           selectedDocumentAtt="#{previsualizacionDocumento.rutaArchivoTemporal}"
                                           showDownloadButton="#{previsualizacionDocumento.documentoDwg}"
                                           fileContent="#{previsualizacionDocumento.reporteDTO.streamedContentReporte}"
                                           doctypeAtt="#{vistaDetallesTramite.tipoMimeDocTemporal}"
                                           headerLabel="Previsualización de documento" yesRendered="false"
                                           noLabel="Cerrar" />
        <ui:include src="../../util/visorGeografico.xhtml" />	

        <misc:visualizadorMemorandosCC id="reportViewer" thisWVName="reportViewerWV"
                                       radicarButtonEnabled="false"
                                       componentsToUpdateOnClose=":tramitesFinalizarForm"
                                       urlDocumento="#{generarResolucionIPER.urlArchivoFichaPredialDigital}"
                                       documentoGenerado="#{generarResolucionIPER.banderaFichaPredialGenerada}"
                                       fileContent="#{generarResolucionIPER.reporteFichaPredialDigital}"	/>

        <misc:visualizadorMemorandosCC
            id="viewReport"
            thisWVName="visorReporteWV"
            urlDocumento="#{generarResolucionIPER.reporteResolucion.urlWebReporte}"
            fileContent="#{generarResolucionIPER.reporteResolucion.streamedContentReporte}"
            documentoGenerado="#{generarResolucionIPER.reporteResolucion ne null}"
            radicarButtonVisible="false"
            cancelButtonEnabled="false"/>			
    </ui:define>

</ui:composition>